<?php

// Ship class
class Ships
{
  protected $length;
  protected $posBegin;
  protected $posEind;
  protected $posMidden;
  protected $amountShots;
  protected $arrPos;
  protected $ammo;


  function __construct()
  {
    $this->createShip();
  }

  protected function createShip()
  {
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
  }


  // Eerste positie van ship
  protected function calcposBegin()
  {
    $this->posBegin = $this->posMidden - floor($this->length / 2);
  }

  // Laatste positie van ship
  protected function calcposEind()
  {
    $this->posEind = $this->posBegin + $this->length - 2;
  }

  // Begin van ship wordt berekend adhv het midden, wat een random getal is tussen 4 en 47
  public function calcposMidden()
  {

    $this->posMidden = rand(4, 47);
  }

  // Opvragen van eerste positie van ship
  public function returnPosBegin()
  {
    return $this->posBegin;
  }

  // Opvragen van laatste positie van ship
  public function returnPosEind()
  {
    return $this->posEind;
  }

  // 
  protected function initPosArr()
  {
    for ($i = $this->posBegin; $i <= $this->posEind; $i++) {
      $this->arrPos[] = $i;
    }
  }



  public function posArr()
  {
    return $this->arrPos;
  }

  public function hitOrMis($shot)
  {
    if ($shot >= $this->posBegin && $shot <= $this->posEind) {
      return true;
    } else {
      return false;
    }
  }
}

class vliegdekSchip extends Ships
{
  protected $shipName;
  protected function createShip()
  {
    $this->length = 8;
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
    $this->shipName = "Vliegdekship";
  }

  public function returnName()
  {
    return $this->shipName;
  }
}
class slagSchip extends Ships
{
  protected $shipName;
  protected function createShip()
  {
    $this->length = 7;
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
    $this->shipName = "Slagship";
  }

  public function returnName()
  {
    return $this->shipName;
  }
}
class kruiser extends Ships
{
  protected $shipName;
  protected function createShip()
  {
    $this->length = 6;
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
    $this->shipName = "Kruiser";
  }

  public function returnName()
  {
    return $this->shipName;
  }
}

class torpedojager extends Ships
{
  protected $shipName;
  protected function createShip()
  {
    $this->length = 5;
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
    $this->shipName = "Torpedojager";
  }

  public function returnName()
  {
    return $this->shipName;
  }
}
class duikboot extends Ships
{
  protected $shipName;
  protected function createShip()
  {
    $this->length = 4;
    $this->calcposMidden();
    $this->calcposBegin();
    $this->calcposEind();
    $this->initPosArr();
    $this->shipName = "Duikboot";
  }

  public function returnName()
  {
    return $this->shipName;
  }
}
